%define momorel 2

# use a trick for SUNWprivate_1.1
%define _use_internal_dependency_generator 0

%define sdk_basename  sun-j2se1.5-sdk

Name: java-sun-j2se1.5-sdk
Version: 1.5.0.10
Release: %{momorel}m

%define mainver 1.5.0.10
%define ulmainver 1_5_0_10
%define dirver 1.5.0_10
%ifarch %{ix86}
%define originalarch i386
%else
%ifarch x86_64
%define originalarch amd64
%endif
%endif

# %%define jcever 1.5
# %%define uljcever 1.5

%define mozver 1.7.13

Summary: Java2 Standard Edition %{version}, Software Development Kit
Group: Development/Languages
URL: http://jdk-distros.dev.java.net/developer.html
License: "Distributor License for Java"

Provides: java-compiler, jdk
Provides: java-virtual-machine, javavm, jre
# java.xml.parsers
Provides: javax-xml-parsers, jaxp-xml-parser, crimson
# java.xml.transform
Provides: javax-xml-transform, xalan
# javax.sql (JDBC extensions)
Provides: javax-sql, jdbc-optional
# javax.naming (JNDI)
Provides: javax-naming, jndi
# javax.net.ssl (JSSE)
Provides: javax-net-ssl, jsse

#
%ifarch x86_64 ppc64 ia64 sparc64
Provides: libjava_crw_demo_g.so()(64bit)
%else
Provides: libjava_crw_demo_g.so
%endif

BuildPreReq: bash, coreutils, sed, tar, unzip
ExclusiveArch: %{ix86} x86_64
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: unixODBC, java-common >= 0.7
PreReq: chkconfig
Obsoletes: java-sun-j2se-devel
Obsoletes: java-sun-j2se-sdk
# apt contains /usr/bin/apt
Conflicts: apt

# Spec options
# - read local spec option definitions.
%{?include_specopt}
# - use defaults for parameters undefined in local spec option definitions.
# Stronger cryptography extension
%{?!enable_strong_cryptography: %global enable_strong_cryptography 0}

%ifarch %{ix86}
%NoSource 0 http://download.java.net/dlj/binaries/jdk-%{ulmainver}-dlj-linux-i586.bin baa5f71d72d1d4d7c38374d59bedfe7c
%else
%ifarch x86_64
%NoSource 0 http://download.java.net/dlj/binaries/jdk-%{ulmainver}-dlj-linux-amd64.bin eca3b5106aa3cb0469ea01b96dc70510
%endif
%endif

%define sdksrc %{SOURCE0}

%if %{enable_strong_cryptography}
Source1: jce_policy-%{uljcever}.zip
NoSource: 1
%define jcesrc %{SOURCE1}
%endif

Source2: fontconfig.properties
%define fontconfig %{SOURCE2}

Source3: http://download.java.net/dlj/DLJ-v1.1.txt
Source4: java-enable.sh

Source30: alternatives.%{sdk_basename}.java
Source31: alternatives.%{sdk_basename}.javac
Source32: alternatives.%{sdk_basename}.lib64.java
Source33: alternatives.%{sdk_basename}.lib64.javac
%ifarch %{ix86}
%define alternativesjava %{SOURCE30}
%define alternativesjavac %{SOURCE31}
%endif
%ifarch x86_64
%define alternativesjava %{SOURCE32}
%define alternativesjavac %{SOURCE33}
%endif

%description
An inplementation of Java 2 platform Standard Edition (J2SE) Software
Development Kit(SDK) by Sun Microsystems Inc.

%package demo
Summary: Java 2 platform, Standard Edition (J2SE), Demonstration programs.
Group: Development/Languages
Requires: java-sun-j2se1.5-sdk = %{mainver}-%{release}
Obsoletes: java-sun-j2se-demo

%description demo
An inplementation of Java 2 platform Standard Edition (J2SE) Software
Development Kit(SDK) by Sun Microsystems Inc.

Demonstration programs.
#---------------------------------------------------------------------------
%ifarch %{ix86}
%package mozilla-plugin
Summary: Java 2 platform, Standard Edition (J2SE), Browsers plugin
Group: Applications/Internet
Requires: mozilla, java-sun-j2se1.5-sdk = %{mainver}-%{release}
Obsoletes: java-sun-j2se-mozilla-plugin

%description mozilla-plugin
An inplementation of Java 2 platform Standard Edition (J2SE) Software
Development Kit(SDK) by Sun Microsystems Inc.

Mozilla plugin.
%endif
#---------------------------------------------------------------------------
%ifarch %{ix86}
%package webstart
Summary: Java Webstart
Group: Applications/Internet
Requires: java-sun-j2se1.5-sdk = %{mainver}-%{release}
Provides: java-webstart
Obsoletes: java-sun-j2se-webstart

%description webstart
An inplementation of Java 2 platform Standard Edition (J2SE) Software
Dvelopment Kit(SDK) by Sun Microsystems Inc.

Java Web Start.
%endif
#---------------------------------------------------------------------------
%define java_lib      %{_libdir}/java
%define java_sharedir %{_datadir}/java
%define java_confdir  %{_sysconfdir}/java
%define alternatives_dir %{java_confdir}/alternatives
%define ext_dir       %{java_confdir}/ext
%define jni_dir       %{java_confdir}/jni

%define sdk_libdir    %{java_lib}/%{sdk_basename}
%define sdk_sharedir  %{java_sharedir}/%{sdk_basename}
%define sdk_confdir   %{java_confdir}/%{sdk_basename}

%define moz_plugindir %{_libdir}/mozilla/plugins
#---------------------------------------------------------------------------
%prep
# clean old files
%__rm -rf jdk%{dirver}

# automatic build hack
if `tty --silent`; then
  sh %{sdksrc} --accept-license --unpack
else
  sh %{sdksrc} --accept-license --unpack > /dev/null <<EOT
yes
EOT
fi

%setup -q -D -T -n jdk%{dirver}

# DLJ-v1.1.txt for java-enable.sh
%__cp %{SOURCE3} ./

%if %{enable_strong_cryptography}
# Overwrite cryptography stuff
%setup -q -D -T -n jdk%{dirver} -a 1
for x in US_export_policy.jar local_policy.jar; do
  %__rm -f jre/lib/security/$x
  %__mv jce/$x jre/lib/security/
done
%endif

#---------------------------------------------------------------------------
%install
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%__mkdir_p %{buildroot}%{_bindir}
%__mkdir_p %{buildroot}%{sdk_libdir}
%__mkdir_p %{buildroot}%{sdk_libdir}/jre
%__mkdir_p %{buildroot}%{sdk_sharedir}

%__mkdir_p %{buildroot}%{sdk_confdir}
%__mkdir_p %{buildroot}%{sdk_confdir}/images/cursors
%__mkdir_p %{buildroot}%{sdk_confdir}/management
%__mkdir_p %{buildroot}%{sdk_confdir}/security
%__mkdir_p %{buildroot}%{sdk_confdir}/%{originalarch}
%__mkdir_p %{buildroot}%{sdk_confdir}/javaws
%__mkdir_p %{buildroot}%{alternatives_dir}
%__mkdir_p %{buildroot}%{ext_dir}
%__mkdir_p %{buildroot}%{jni_dir}

# FHS places configuration files under /etc:
%__install -m644 %{fontconfig} jre/lib
%__rm -f jre/lib/fontconfig.RedHat.bfc
#%%__mv jre/lib/jvm.hprof.txt jre

for dir in /jre/lib /jre/lib/images/cursors /jre/lib/management; do
  pushd ./$dir
  dir=`echo $dir|sed 's,/jre/lib,,'`
  for prop in *.properties; do
    %__mv $prop %{buildroot}%{sdk_confdir}$dir
    %__ln_s -f %{sdk_confdir}$dir/$prop .
  done
  popd
done
ls -lR %{buildroot}%{sdk_confdir}

pushd jre/lib/security
%__tar cf - cacerts java.* | (cd %{buildroot}%{sdk_confdir}/security; %__tar xpf -)
%ifarch %{ix86}
%__tar cf - javaws.policy | (cd %{buildroot}%{sdk_confdir}/security; %__tar xpf -)
%endif
ls %{buildroot}%{sdk_confdir}/security | while read x; do
  %__rm $x
  %__ln_s -f %{sdk_confdir}/security/$x .
done
popd # jre/lib/security

pushd jre/lib/%{originalarch}
%__mv jvm.cfg %{buildroot}%{sdk_confdir}/%{originalarch}
%__ln_s -f %{sdk_confdir}/%{originalarch}/jvm.cfg .
popd # jre/lib/%{originalarch}

%ifarch %{ix86}
pushd jre/lib/javaws
for x in *.properties; do
  %__mv $x %{buildroot}%{sdk_confdir}/javaws
  %__ln_s %{sdk_confdir}/javaws/$x .
done
%__chmod 644 %{buildroot}%{sdk_confdir}/javaws/*.properties
popd # jre/lib/javaws
%endif

%ifarch %{ix86}
# remove mozilla gcc29 plugin
%__rm -rf jre/plugin/%{originalarch}/ns7-gcc29
%endif

# remove .systemPrefs directory
%__rm -rf jre/.systemPrefs

# rename Japanese man directory
%__rm man/ja
%__mv man/ja_JP.eucJP man/ja

%ifarch x86_64
# remove unused file
%__rm -rf man/man1/javaws.1
%endif

# Install the SDK
%__tar cf - bin include lib        | (cd %{buildroot}%{sdk_libdir};   %__tar xpf -)
%__tar cf - jre/bin jre/lib        | (cd %{buildroot}%{sdk_libdir};   %__tar xpf -)
%ifarch %{ix86}
%__tar cf - jre/javaws jre/plugin  | (cd %{buildroot}%{sdk_libdir};   %__tar xpf -)
%endif
%__tar cf - demo man sample src.zip| (cd %{buildroot}%{sdk_sharedir}; %__tar xpf -)

# Fake %_mandir for brp-compress. This directory is not part of package.
%__mkdir_p %{buildroot}%{_datadir}
bzip2 -9 %{buildroot}%{sdk_sharedir}/man/man1/*
bzip2 -9 %{buildroot}%{sdk_sharedir}/man/ja/man1/*

# Install alternatives metainfo
%__install -m644 %{alternativesjava}       %{buildroot}%{alternatives_dir}/%{sdk_basename}.java
%__install -m644 %{alternativesjavac}      %{buildroot}%{alternatives_dir}/%{sdk_basename}.javac

# Install extension directory
%__ln_s -f %{sdk_libdir}/jre/lib/ext %{buildroot}/%{ext_dir}/%{sdk_basename}

# Install native library directory
%__ln_s -f %{sdk_libdir}/jre/lib/%{originalarch} %{buildroot}/%{jni_dir}/%{sdk_basename}

# move files to find documents easily.
%__mkdir jre-nondocs
%__mv jre/bin jre/lib jre-nondocs
%ifarch %{ix86}
%__mv jre/javaws jre/plugin jre-nondocs
%endif

# make file list
(find %{buildroot}%{sdk_libdir}/bin -print;
 find %{buildroot}%{sdk_libdir}/jre/bin -print) | \
  sed '/javaws/d;/bin$/d;s,^%{buildroot},,' \
  > list
find %{buildroot}%{sdk_libdir} -type l -print | \
  sed '/javaws/d;s,%{buildroot},,' \
  >> list
find %{buildroot}%{sdk_libdir}/jre/lib -type f -print | \
  sed '/plugin/d;/javaws/d;s,^%{buildroot},,' \
  >> list
find %{buildroot}%{sdk_libdir}/include -type f -print | \
  sed '/plugin/d;/javaws/d;s,^%{buildroot},,' \
  >> list
find %{buildroot}%{sdk_libdir}/lib -type f -print | \
  sed '/plugin/d;/javaws/d;s,^%{buildroot},,' \
  >> list
find %{buildroot}%{sdk_sharedir}/man -type f -print | \
  sed '/javaws/d;s,^%{buildroot},,' \
  >> list
#find %{buildroot}%{sdk_sharedir} -type d -print | \
#  sed '/javaws/d;s,^%{buildroot},%dir ,' \
#  >> list
cat list > /var/tmp/list.java

%__install -m755 %{SOURCE4} %{buildroot}%{_bindir}/

#---------------------------------------------------------------------------
%clean
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

#---------------------------------------------------------------------------
%post
/usr/bin/java-config --quiet --update-extensions
/usr/bin/java-config --quiet --update-natives

## mv this block to java-enable.sh
# remove comment out after Mo3 release.
#[ $1 = 1 ] || exit 0
# /usr/bin/java-config --quiet --install-alternatives %{alternatives_dir}/%{sdk_basename}.java
# /usr/bin/java-config --quiet --install-alternatives %{alternatives_dir}/%{sdk_basename}.javac
exit 0
#---------------------------------------------------------------------------
%preun
#---------------------------------------------------------------------------
[ $1 = 0 ] || exit 0
/usr/bin/java-config --quiet --remove-extensions %{sdk_basename}
/usr/bin/java-config --quiet --remove-natives %{sdk_basename}

/usr/bin/java-config --quiet --remove-alternatives %{alternatives_dir}/%{sdk_basename}.java
/usr/bin/java-config --quiet --remove-alternatives %{alternatives_dir}/%{sdk_basename}.javac
exit 0
#---------------------------------------------------------------------------
%ifarch %{ix86}
%post mozilla-plugin
[ $1 = 1 ] || exit 0
/usr/sbin/alternatives --install \
  %{moz_plugindir}/libjavaplugin_oji.so libjavaplugin_oji.so %{sdk_libdir}/jre/plugin/%{originalarch}/ns7/libjavaplugin_oji.so \
  80
exit 0
#---------------------------------------------------------------------------
%preun mozilla-plugin
[ $1 = 0 ] || exit 0
/usr/sbin/alternatives --remove libjavaplugin_oji.so %{sdk_libdir}/jre/plugin/%{originalarch}/ns7/libjavaplugin_oji.so
exit 0
%endif
#---------------------------------------------------------------------------
%ifarch %{ix86}
%post webstart
[ $1 = 1 ] || exit 0
/usr/sbin/alternatives --install \
  %{_bindir}/javaws javaws %{sdk_libdir}/bin/javaws \
  80 \
  --slave %{_mandir}/man1/javaws.1.bz2 javaws.1.bz2 %{sdk_sharedir}/man/man1/javaws.1.bz2 \
  --slave %{_mandir}/ja/man1/javaws.1.bz2 javaws.1.ja.bz2 %{sdk_sharedir}/man/ja/man1/javaws.1.bz2
exit 0
#---------------------------------------------------------------------------
%preun webstart
[ $1 = 0 ] || exit 0
/usr/sbin/alternatives --remove javaws %{sdk_libdir}/bin/javaws

exit 0
%endif
#---------------------------------------------------------------------------
%files -f list
%defattr(-,root,root)
%dir %{sdk_confdir}
%dir %{sdk_confdir}/%{originalarch}
%dir %{sdk_confdir}/images
%dir %{sdk_confdir}/images/cursors
%dir %{sdk_confdir}/management
%dir %{sdk_confdir}/security
%dir %{sdk_libdir}/include
%dir %{sdk_libdir}/lib
%{sdk_sharedir}/src.zip
%{alternatives_dir}/%{sdk_basename}.java
%{alternatives_dir}/%{sdk_basename}.javac
%{ext_dir}/%{sdk_basename}
%{jni_dir}/%{sdk_basename}
%config %{sdk_confdir}/*.properties*
%config %{sdk_confdir}/%{originalarch}/jvm.cfg
%config %{sdk_confdir}/images/cursors/cursors.properties
%config %{sdk_confdir}/management/management.properties
%config %{sdk_confdir}/security/cacerts
%config %{sdk_confdir}/security/java.policy
%config %{sdk_confdir}/security/java.security
%{_bindir}/java-enable.sh

%doc COPYRIGHT LICENSE README.html DLJ-v1.1.txt
%doc jre
%if %{enable_strong_cryptography}
%doc jce
%endif
#---------------------------------------------------------------------------
%files demo
%defattr(-,root,root)
%{sdk_sharedir}/demo
%{sdk_sharedir}/sample
#---------------------------------------------------------------------------
%ifarch %{ix86}
%files mozilla-plugin
%defattr(-,root,root)
%{sdk_libdir}/jre/plugin
%{sdk_libdir}/jre/lib/%{originalarch}/libjavaplugin_*.so
%{sdk_libdir}/jre/lib/plugin.jar
%{sdk_libdir}/jre/lib/locale/*/LC_MESSAGES/sunw_java_plugin.mo
%endif
#---------------------------------------------------------------------------
%ifarch %{ix86}
%files webstart
%defattr(-,root,root)
%{sdk_libdir}/bin/javaws
%{sdk_libdir}/jre/bin/javaws
%{sdk_libdir}/jre/lib/javaws
%{sdk_libdir}/jre/lib/javaws.jar
%{sdk_libdir}/jre/javaws
%dir %{sdk_confdir}/javaws
%{sdk_sharedir}/man/man1/javaws.1.*
%{sdk_sharedir}/man/ja/man1/javaws.1.*
%{sdk_libdir}/jre/lib/security/javaws.policy
%config %{sdk_confdir}/security/javaws.policy
%config %{sdk_confdir}/javaws/*.properties
%endif

#---------------------------------------------------------------------------

%changelog
* Fri Dec 29 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.5.0.10-2m)
- modify spec file for new firefox and seamonkey

* Thu Dec 14 2006 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.5.0.10-1m)
- update to 1.5.0_10
- [SECURITY] CVE-2007-0243

- log from T4R
- * Sun Dec 10 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- - (1.5.0.10-1m)
- - update to 1.5.0.10
- - good-bye mozilla

* Tue Nov  7 2006 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.5.0.08-2m)
- must not move jvm.hprof.txt, can not use hprof

* Fri Aug 18 2006 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.5.0.08-1m)
- update to 1.5.0_08

* Tue Jul 25 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.5.0.07-3m)
- add java-enable.sh, DLJ-v1.1.txt for Mo3
- please execute "java-enable.sh" using before eclipse3, ant, and so on.
- execute java-enable.sh only once when you newly install java-sdk. 

* Sun Jul 16 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.5.0.07-2m)
- modify spec for 64bit arch

* Wed Jul 12 2006 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.5.0.07-1m)
- new version

* Mon Jun 26 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.5.0.06-6m)
- modify alternatives for lib64

* Wed Jun  7 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.5.0.06-5m)
- delete duplicated files

* Sat Jun  3 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.5.0.06-4m)
- x86_64 without java-webstart, java-mozilla-plugin

* Thu Jun  1 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.5.0.06-3m)
- modify amd64 as x86_64

* Thu Jun  1 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.5.0.06-2m)
- use Distributor License for Java

* Fri Dec  2 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.5.0.06-1m)
- new version

* Tue Nov 15 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.5.0.05-1m)
- new version

* Tue Jun 28 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.5.0.04-1m)
- new version

* Fri Mar 25 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.5.0.02-2m)
- rebuild against mozilla-1.7.6
- install mozilla-plugin to %%{_libdir}/mozilla/plugins

* Mon Mar 14 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.5.0.02-1m)
- new version

* Fri Dec 24 2004 Shigeyuki Yamashita <shige@momonga-linux.org>
- (1.5.0.01-2m)
- rebuild against mozilla-1.7.5

* Thu Dec 23 2004 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.5.0.01-1m)
- new version

* Tue Dec 21 2004 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.5-1m)
- initial import
